require 'osx/cocoa'
require 'net/http'
require 'cgi'


# http://frankmao.com/2011/07/28/character-encoding-in-ruby/
def unicode_to_utf8(unicode_string)
	unicode_string.gsub(/\\u\w{4}/) do |s|
		str = s.sub(/\\u/, "").hex.to_s(2)
		if str.length < 8
		  CGI.unescape(str.to_i(2).to_s(16).insert(0, "%"))
		else
		  arr = str.reverse.scan(/\w{0,6}/).reverse.select{|a| a != ""}.map{|b| b.reverse}
		  hex = lambda do |s|
		    (arr.first == s ? "1" * arr.length + "0" * (8 - arr.length - s.length) + s : "10" + s).to_i(2).to_s(16).insert(0, "%")
		  end
		  CGI.unescape(arr.map(&hex).join)
		end
	end
end

response = Net::HTTP.get_response("emojicons.com","/random.json")
# if you're using system ruby we don't have JSON

# use a random index in the response array
responseArray =  response.body.split("\"text\":\"")
index = rand(1 + (responseArray.length - 1))
text = responseArray[index].split("\",\"title\":")[0]
text = text.sub("\\\\", "\\")

# copy to clipboard - third attempt
#`echo "#{ unicode_to_utf8 text }" | pbcopy `
#`osascript -e 'set the clipboard to \xc7data utf8 #{ unicode_to_utf8 text } \xc8'`

# rubycocoa to the rescue!
ns_string = OSX::NSString.stringWithString unicode_to_utf8(text) 
pb = OSX::NSPasteboard.generalPasteboard
pb.declareTypes_owner_(["NSStringPboardType"], nil)
pb.setString_forType_(ns_string, "NSStringPboardType")

#paste
`osascript -e 'tell application "System Events" to keystroke "v" using command down'`
